﻿using System;
using System.Drawing;
using EveMapSettings.FormState;

namespace EveMapSettings
{
    [Serializable]
    public class ApplicationState
    {
        public GatePlannerState GPState;
        public JumpPlannerState JPState;
        public ManualJumpPlannerState MJPState;
        public MainWindowState MWState;

        public void LoadDefaultSettings()
        {
            MWState = new MainWindowState
                          {
                              MapScale = .50001f,
                              SelectedSystem = 30004712,
                              SelectedTab = 1,
                              ZoomLevel = 8,
                              WindowLocation = new Point(10, 10),
                              WindowSize = new Size(1024, 768)
                          };
            GPState = new GatePlannerState
                          {
                              AvoidNone = true,
                              FilterRoute = true,
                              UseBridges = true,
                              FilterSystems = true
                          };
            JPState = new JumpPlannerState
                          {
                              JDC = 4,
                              JF = 4,
                              JFC = 4,
                              Ship = 4,
                              UseBeacons = true
                          };
            MJPState = new ManualJumpPlannerState
                           {
                               JDC = 4,
                               JF = 4,
                               JFC = 4,
                               Ship = 4
                           };
        }
    }
}