﻿using System;
using System.Drawing;
using libEveMapNG.Data.Static;

namespace EveMapSettings
{
    [Serializable]
    public class ViewportSettings
    {
        public string Name;
        private int _sysMarkerDiameter;
        private int _sysMarkerMargin;

        public string MapLabelFontFamily { get; set; }

        public string SystemLabelFontFamily { get; set; }

        public string DetailTextFontFamily { get; set; }

        public Size Margin { get; set; }

        public int LineThickness { get; set; }

        public bool ShowRegionNames { get; set; }

        public bool ShowConstNames { get; set; }

        public bool ShowSystemNames { get; set; }

        public bool ShowSystemDetails { get; set; }

        public bool ShowJumpbridges { get; set; }

        public bool ShowSovCircles { get; set; }

        public bool ShowPosStatusCircles { get; set; }

        public bool ShowCynoGenerators { get; set; }

        public bool ShowMiniMap { get; set; }

        public EVEMapDetailText DetailText { get; set; }

        public int SystemMarkerSize { get; private set; }
        public int SystemMarkerThickness { get; private set; }

        public int SystemMarkerDiameter
        {
            get { return _sysMarkerDiameter; }
            set
            {
                _sysMarkerDiameter = value;
                SystemMarkerThickness = value/2;
                SystemMarkerSize = 2*_sysMarkerMargin + _sysMarkerDiameter;
            }
        }

        public int SystemMarkerMargin
        {
            get { return _sysMarkerMargin; }
            set
            {
                _sysMarkerMargin = value;
                SystemMarkerSize = 2*_sysMarkerMargin + _sysMarkerDiameter;
            }
        }
    }
}