#region

using System;
using System.Collections.Generic;

#endregion

namespace Eve_Class_Library
{
    [Serializable]
    public class EVEStationList : List<EVEStation>
    {
        public EVEStation GetByID(int id)
        {
            foreach (EVEStation station in this)
            {
                if (station.ID == id) return station;
            }

            return null;
        }
    }

    [Serializable]
    public class EVEStation : List<EVEAgent>
    {
        public bool Conquerable;
        public int ID;
        public string Name;
        public EVECorpNPC ParentCorpNPC;
        public EVESystem ParentSystem;
        public float Reprocess;

        public int ServiceBitmask;
        public EVEStationType StationType;
    }

    [Serializable]
    public class EVEStationMetaList
    {
        private readonly List<EVEService> services = new List<EVEService>();
        private readonly List<EVEStationType> stationTypes = new List<EVEStationType>();

        public List<EVEStationType> StationTypes
        {
            get { return stationTypes; }
        }

        public List<EVEService> Services
        {
            get { return services; }
        }

        public EVEStationType GetStationTypeByID(int id)
        {
            foreach (EVEStationType curStationType in stationTypes)
            {
                if (curStationType.ID == id) return curStationType;
            }

            return null;
        }

        public EVEService GetServiceByID(int id)
        {
            foreach (EVEService curService in services)
            {
                if (curService.ID == id) return curService;
            }

            return null;
        }

        public IEnumerable<EVEService> GetServiceListFromBitmask(int ID)
        {
            foreach (EVEService serv in services)
                if ((serv.ID & ID) == serv.ID)
                    yield return serv;
        }
    }

    [Serializable]
    public class EVEStationType
    {
        public bool Conquerable;
        public int ID;
        public string Name;
        public byte OfficeSlots;
    }

    [Serializable]
    public class EVEService
    {
        public int ID;
        public string Name;
    }
}