﻿using System;
using System.Collections.Generic;
using libEveMapNG.Data.Static;

namespace libEveMapNG.Data.Dynamic
{
    /// <summary>
    ///   Contains all extra variables needed for a jump route
    /// </summary>
    [Serializable]
    public class JumpRouteParameters : RouteParameters
    {
        public JumpRouteParameters()
        {
            AvoidSystems = new List<SolarSystem>();
            WayPoints = new List<SolarSystem>();
        }

        public ShipProfile CapitalShipProfile { get; set; }
    }

    [Serializable]
    public class ShipProfile
    {
        public int JDC { get; set; }
        public int JFC { get; set; }
        public int JF { get; set; }
        public CapitalShips.Ship Ship { get; set; }
    }
}