using System.Collections.Generic;
using libEveMapNG.Data.Static;

namespace libEveMapNG.Data.Dynamic
{
    /// <summary>
    ///   Contains all the variables that are common to both jump and gate routes
    /// </summary>
    public class RouteParameters
    {
        public List<SolarSystem> AvoidSystems;
        public bool UseBeacons;
        public bool UseBridges;

        public SolarSystem StartSystem { get; set; }
        public List<SolarSystem> WayPoints { get; set; }
        public SolarSystem DestSystem { get; set; }
    }


    public enum JumpType
    {
        Cyno,
        Gate,
        Bridge,
        Beacon,
        Undefined
    }
}