using System;
using System.Collections.Generic;

namespace libEveMapNG.Data.Static
{
    [Serializable]
    public class Station
    {
        public int SolarSystemID { get; set; }
        public int ID { get; set; }
        public string Name { get; set; }
        public string Owner { get; set; }
        public double Refine { get; set; }
        public bool Factory { get; set; }
        public bool Cloning { get; set; }
        public List<String> Services { get; set; }
        public int Faction { get; set; }
        public List<Agent> Agents { get; set; }

        public static Station GetByID(int ID)
        {
            foreach (Station station in StaticStore.Stations)
            {
                if (station.ID == ID)
                    return station;
            }
            return null;
        }

        public static bool operator ==(Station a, Station b)
        {
            // If both are null, or both are same instance, return true.
            if (ReferenceEquals(a, b))
                return true;
            // If one is null, but not both, return false.
            if (((object) a == null) || ((object) b == null))
                return false;
            return a.ID == b.ID;
        }

        public static bool operator !=(Station a, Station b)
        {
            return !(a == b);
        }

        public bool Equals(Station obj)
        {
            if (ReferenceEquals(null, obj))
                return false;
            if (ReferenceEquals(this, obj))
                return true;
            return obj.ID == ID;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
                return false;
            if (ReferenceEquals(this, obj))
                return true;
            if (obj.GetType() != typeof (Station))
                return false;
            return Equals((Station) obj);
        }

        public override int GetHashCode()
        {
            return ID;
        }
    }

    [Serializable]
    public class StationType
    {
        public bool Conquerable;
        public short ID;
        public short OfficeSlots;
        public double ReprocessingEffeciency;
    }
}