using System;
using System.Drawing;
using libeveapi;
using libEveMapNG.Data.Dynamic;

namespace libEveMapNG.EveAPI.Data
{
    [Serializable]
    public class Alliance
    {
        public string Name { get; set; }
        public string Ticker { get; set; }
        public int ID { get; set; }
        public Color Color { get; set; }

        public static void UpdateAlliances()
        {
            AllianceList allianceList = EveApi.GetAllianceList();
            Alliance myAlliance;
            int count = 0;
            foreach (AllianceList.AllianceListItem alliance in allianceList.AllianceListItems)
            {
                if (DynamicStore.Instance.ApiData.Alliances.ContainsKey(alliance.AllianceId))
                    continue;
                myAlliance = new Alliance
                                 {
                                     ID = alliance.AllianceId,
                                     Name = alliance.Name,
                                     Ticker = alliance.ShortName
                                 };
                DynamicStore.Instance.ApiData.Alliances.Add(alliance.AllianceId, myAlliance);
                count++;
            }
        }
    }
}