using System;
using System.Collections.Generic;
using System.Drawing;
using libeveapi;
using libEveMapNG.Data.Dynamic;
using libEveMapNG.Utility;

namespace libEveMapNG.EveAPI.Data
{
    [Serializable]
    public class Sovereignty
    {
        public int SolarSystemId { get; set; }
        public int AllianceId { get; set; }

        public static void UpdateSovereignty()
        {
            List<Color> allianceColors = AllianceColors.GenerateRandomizedColors();
            MapSovereignty mapSovereignty = EveApi.GetMapSovereignty();
            Sovereignty mySov;
            int count = 0;
            foreach (MapSovereignty.MapSovereigntyItem sov in mapSovereignty.MapSystemSovereigntyItems)
            {
                if (sov.AllianceId == 0)
                    continue;
                mySov = new Sovereignty
                            {
                                AllianceId = sov.AllianceId,
                                SolarSystemId = sov.SolarSystemId
                            };
                if (sov.AllianceId != 0 && DynamicStore.Instance.ApiData.Alliances[sov.AllianceId].Color.IsEmpty)
                {
                    DynamicStore.Instance.ApiData.Alliances[sov.AllianceId].Color = allianceColors[count];
                    count++;
                }
                if (
                    DynamicStore.Instance.ApiData.MapSovereignty.ContainsKey(
                        sov.SolarSystemId))
                {
                    DynamicStore.Instance.ApiData.MapSovereignty[sov.SolarSystemId] =
                        mySov;
                }
                else
                {
                    DynamicStore.Instance.ApiData.MapSovereignty.Add(
                        sov.SolarSystemId, mySov);
                }
            }
        }
    }
}