﻿using libeveapi;
using libEveMapNG.Data.Dynamic;
using libEveMapNG.Data.Static;

namespace libEveMapNG.EveAPI.Data
{
    public class Starbases
    {
        public static void ImportUpdateStarbases(ApiInfo apiInfo, int CharID)
        {
            StarbaseList starbaseList = EveApi.GetStarbaseList(apiInfo.UserID, CharID, apiInfo.FullApiKey);

            foreach (StarbaseList.StarbaseListItem sli in starbaseList.StarbaseListItems)
            {
                if (DynamicStore.Instance.ApiData.Starbases.ContainsKey(sli.ItemId))
                    UpdateStarbases(apiInfo, CharID, sli);
                else
                    ImportStarbases(apiInfo, CharID, sli);

                DynamicStore.Instance.ApiData.Starbases[sli.ItemId].LastUpdate = starbaseList.CurrentTimeLocal;
            }
        }

        private static void UpdateStarbases(ApiInfo apiInfo, int CharID, StarbaseList.StarbaseListItem sli)
        {
            Starbase myPos = DynamicStore.Instance.ApiData.Starbases[sli.ItemId];

            StarbaseDetail starbaseDetail = EveApi.GetStarbaseDetail(apiInfo.UserID, CharID, apiInfo.FullApiKey,
                                                                     sli.ItemId);
            foreach (StarbaseDetail.FuelListItem list in starbaseDetail.FuelList)
            {
                myPos.GetFuelByID(list.TypeId).Quantity = (int) list.Quantity;
            }
        }

        private static void ImportStarbases(ApiInfo apiInfo, int CharID, StarbaseList.StarbaseListItem sli)
        {
            Starbase myPos = Starbase.Copy(StaticStore.Instance.StarbaseTypes[sli.TypeId]);
            myPos.SolarSystemID = sli.LocationId;
            myPos.Moon = sli.MoonId;

            StarbaseDetail starbaseDetail = EveApi.GetStarbaseDetail(apiInfo.UserID, CharID, apiInfo.FullApiKey,
                                                                     sli.ItemId);

            foreach (StarbaseDetail.FuelListItem fli in starbaseDetail.FuelList)
            {
                myPos.GetFuelByID(fli.TypeId).Quantity = (int) fli.Quantity;
            }
            DynamicStore.Instance.ApiData.Starbases.Add(sli.ItemId, myPos);
        }
    }
}