﻿#region

using System;
using System.Collections.Generic;
using libEveMapNG.Data.Static;

#endregion

namespace libEveMapNG.Filtering
{
    public class Minerals
    {
        #region IceTypes enum

        [Flags]
        public enum IceTypes
        {
            None = 0x000,
            BlueIce = 0x001, /* gallente highsec */
            ClearIcicle = 0x002, /* amarr highsec */
            WhiteGlaze = 0x004, /* caldari highsec  */
            GlacialMass = 0x008, /* minmatar highsec */
            EnrichedClearIcicle = 0x010, /* blood raider, sansha */
            PristineWhiteGlaze = 0x020, /* guristas */
            SmoothGlacialMass = 0x040, /* angels */
            ThickBlueIce = 0x080, /* serpentis */
            GlareCrust = 0x100, /* > -0.15, < 0.35 */
            DarkGlitter = 0x200, /* > -0.45, < 0.15 */
            Gelidus = 0x400, /* > -0.65, < -0.15 */
            Krystallos = 0x800 /* < -0.45 */
        }

        #endregion

        #region OreTypes enum

        [Flags]
        public enum OreTypes
        {
            None = 0x0000,
            Veldspar = 0x0001,
            Scordite = 0x0002,
            Pyroxeres = 0x0004,
            Plagioclase = 0x0008,
            Jaspet = 0x0010,
            Gneiss = 0x0020,
            Kernite = 0x0040,
            Omber = 0x0080,
            Spodumain = 0x0100,
            Hemorphite = 0x0200,
            Hedbergite = 0x0400,
            DarkOchre = 0x0800,
            Crokite = 0x1000,
            Bistot = 0x2000,
            Mercoxit = 0x4000,
            Arkonor = 0x8000
        }

        #endregion

        /*public static OreTypes GetOres(SolarSystem system)
        {
            var Compound = OreTypes.None;

            switch (system.SecurityClass)
            {
                case 0: // A
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite;
                    break;
                case 1: // B
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite;
                    switch (system.SecurityClass)
                    {
                        case 3:
                            Compound |= OreTypes.Hemorphite;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Jaspet;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Kernite;
                            goto case 0;
                        case 0:
                            if (system.ParentRegion.ParentFaction != null &&
                                system.ParentRegion.ParentFaction.Name == "Gallente Federation")
                                Compound |= OreTypes.Plagioclase;
                            else Compound |= OreTypes.Pyroxeres;
                            break;
                    }
                    break;
                case 2: // C
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Plagioclase | OreTypes.Pyroxeres;
                    switch (system.SecurityClassNumber)
                    {
                        case 2:
                            Compound |= OreTypes.Hedbergite;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Kernite;
                            break;
                    }
                    break;
                case 3: // D
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Plagioclase;
                    switch (system.SecurityClassNumber)
                    {
                        case 3:
                            Compound |= OreTypes.Hemorphite;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Jaspet;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Omber;
                            break;
                    }
                    break;
                case 4: // E
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Plagioclase | OreTypes.Omber |
                                OreTypes.Kernite;
                    switch (system.SecurityClassNumber)
                    {
                        case 1:
                            Compound |= OreTypes.Hedbergite;
                            break;
                    }
                    break;
                case 5: // F
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Hedbergite | OreTypes.Hemorphite |
                                OreTypes.Omber;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.Plagioclase;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Pyroxeres;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.Arkonor;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Bistot;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Gneiss;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Spodumain;
                            break;
                    }
                    break;
                case 6: // G
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Plagioclase | OreTypes.Omber |
                                OreTypes.Kernite;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.DarkOchre;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Crokite;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.Bistot;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Spodumain;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Pyroxeres;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Gneiss;
                            break;
                    }
                    break;
                case 7: // H
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Pyroxeres | OreTypes.Hemorphite |
                                OreTypes.Jaspet;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.Bistot;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Spodumain;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.Crokite;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Kernite;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.DarkOchre;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Hedbergite;
                            break;
                    }
                    break;
                case 8: // I
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Hedbergite | OreTypes.Hemorphite |
                                OreTypes.Omber;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.Kernite;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Arkonor;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.DarkOchre;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Gneiss;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Spodumain;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.Jaspet;
                            break;
                    }
                    break;
                case 9: // J
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Pyroxeres | OreTypes.Plagioclase |
                                OreTypes.Jaspet;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.Arkonor;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Hedbergite;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.Hemorphite;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Bistot;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Crokite;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.DarkOchre;
                            break;
                    }
                    break;
                case 10: // K
                    Compound |= OreTypes.Veldspar | OreTypes.Scordite | OreTypes.Hedbergite | OreTypes.Hemorphite |
                                OreTypes.Omber;
                    switch (system.SecurityClassNumber)
                    {
                        case 7:
                            Compound |= OreTypes.Gneiss;
                            goto case 6;
                        case 6:
                            Compound |= OreTypes.Mercoxit;
                            goto case 5;
                        case 5:
                            Compound |= OreTypes.Arkonor;
                            goto case 4;
                        case 4:
                            Compound |= OreTypes.Bistot;
                            goto case 3;
                        case 3:
                            Compound |= OreTypes.Crokite;
                            goto case 2;
                        case 2:
                            Compound |= OreTypes.Spodumain;
                            goto case 1;
                        case 1:
                            Compound |= OreTypes.DarkOchre;
                            break;
                    }
                    break;
            }

            return Compound;
        }*/

        /*public static IceTypes GetIces(EVESystem system)
        {
            var Compound = IceTypes.None;

            if (system.Security < -0.45) Compound |= IceTypes.Krystallos;
            if (system.Security > -0.65 && system.Security < -0.15) Compound |= IceTypes.Gelidus;
            if (system.Security > -0.45 && system.Security < +0.15) Compound |= IceTypes.DarkGlitter;
            if (system.Security > -0.15 && system.Security < +0.35) Compound |= IceTypes.GlareCrust;

            if (system.ParentRegion.ParentFaction != null)
            {
                switch (system.ParentRegion.ParentFaction.Name)
                {
                    case "Caldari State":
                        Compound |= IceTypes.WhiteGlaze;
                        break;
                    case "Minmatar Republic":
                    case "Ammatar Mandate":
                        Compound |= IceTypes.GlacialMass;
                        break;
                    case "Amarr Empire":
                    case "Khanid Kingdom":
                        Compound |= IceTypes.ClearIcicle;
                        break;
                    case "Gallente Federation":
                        Compound |= IceTypes.BlueIce;
                        break;
                }
            }
            switch (system.ParentRegion.Name)
            {
                case "Vale of the Silent":
                case "Tribute":
                case "Venal":
                case "Geminate":
                case "Deklein":
                case "Tenal":
                case "Branch":
                    Compound |= IceTypes.PristineWhiteGlaze;
                    break;
                case "Detorid":
                case "Wicked Creek":
                case "Cache":
                case "Scalding Pass":
                case "Insmother":
                case "Great Wildlands":
                case "Curse":
                case "Immensea":
                case "Impass":
                case "Feythabolis":
                case "Tenerifis":
                case "Omist":
                    Compound |= IceTypes.SmoothGlacialMass;
                    break;
                case "Catch":
                case "Stain":
                case "Esoteria":
                case "Providence":
                case "Querious":
                case "Paragon Soul":
                case "Delve":
                case "Period Basis":
                    Compound |= IceTypes.EnrichedClearIcicle;
                    break;
                case "Pure Blind":
                case "Syndicate":
                case "Fade":
                case "Cloud Ring":
                case "Outer Ring":
                case "Fountain":
                    Compound |= IceTypes.ThickBlueIce;
                    break;
                case "LQ-0QN":
                case "VU-WU2":
                case "6HL8-L":
                case "7-KXBJ":
                case "87-1CW":
                case "G5KW-3":
                case "H3J8-U":
                case "S-I6VU":
                    break;
            }

            return Compound;
        }*/

        public static List<string> ListComposition(OreTypes ores)
        {
            var newList = new List<string>();
            foreach (OreTypes ore in Enum.GetValues(typeof (OreTypes)))
                if ((int) ore != 0 && (ore & ores) == ore) newList.Add(ore.ToString());

            return newList;
        }

        public static List<string> ListComposition(IceTypes ices)
        {
            var newList = new List<string>();
            foreach (IceTypes ice in Enum.GetValues(typeof (IceTypes)))
                if ((int) ice != 0 && (ice & ices) == ice) newList.Add(ice.ToString());

            return newList;
        }
    }

    public enum FilterScope
    {
        Systems,
        Stations,
        Agents
    }

    [Serializable]
    public class FilterList : List<Filter>
    {
        public FilterScope Scope = FilterScope.Systems;


        public bool TestSystem(SolarSystem system)
        {
            int passed = 0;

            switch (Scope)
            {
                case FilterScope.Systems:
                    foreach (Filter f in this)
                    {
                        if (!f.TestSystem(system)) break;
                        passed++;
                    }
                    if (passed == Count) return true;

                    break;
                case FilterScope.Stations:
                    if (system.Stations != null)
                        foreach (Station station in system.Stations)
                        {
                            passed = 0;
                            foreach (Filter f in this)
                            {
                                if (!f.TestStation(station)) break;
                                passed++;
                            }
                            if (passed == Count) return true;
                        }
                    break;
                case FilterScope.Agents:
                    if (system.Stations != null)
                        foreach (Station station in system.Stations)
                        {
                            if (station.Agents != null)
                                foreach (Agent agent in station.Agents)
                                {
                                    passed = 0;
                                    foreach (Filter f in this)
                                    {
                                        if (!f.TestAgent(agent)) break;
                                        passed++;
                                    }
                                    if (passed == Count) return true;
                                }
                        }
                    break;
            }
            return false;
        }

        public bool TestStation(Station station)
        {
            int passed = 0;

            switch (Scope)
            {
                case FilterScope.Systems:
                    foreach (Filter f in this)
                    {
                        if (!f.TestSystem(SolarSystem.GetByID(station.SolarSystemID))) break;
                        passed++;
                    }
                    if (passed == Count) return true;
                    break;
                case FilterScope.Stations:
                    passed = 0;
                    foreach (Filter f in this)
                    {
                        if (!f.TestStation(station)) break;
                        passed++;
                    }
                    if (passed == Count) return true;
                    break;
                case FilterScope.Agents:
                    for (int i = 0; i < station.Agents.Count; i++)
                    {
                        passed = 0;
                        foreach (Filter f in this)
                        {
                            if (!f.TestAgent(station.Agents[i])) break;
                            passed++;
                        }
                        if (passed == Count) return true;
                    }
                    break;
            }
            return false;
        }

        public bool TestAgent(Agent agent)
        {
            int passed = 0;

            switch (Scope)
            {
                case FilterScope.Systems:
                    foreach (Filter f in this)
                    {
                        if (!f.TestSystem(SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID))) break;
                        passed++;
                    }
                    if (passed == Count) return true;
                    break;
                case FilterScope.Stations:
                    passed = 0;
                    foreach (Filter f in this)
                    {
                        if (!f.TestStation(Station.GetByID(agent.StationID))) break;
                        passed++;
                    }
                    if (passed == Count) return true;
                    break;
                case FilterScope.Agents:
                    passed = 0;
                    foreach (Filter f in this)
                    {
                        if (!f.TestAgent(agent)) break;
                        passed++;
                    }
                    if (passed == Count) return true;
                    break;
            }
            return false;
        }
    }

    public enum FilterType
    {
        FactionID,
        CorporationID,
        AgentLevel,
        AgentQuality,
        AgentIsLocator,
        AgentDivisionID,
        AgentTypeID,
        StationReprocessing,
        StationManufacturing,
        StationCloning,
        RegionID,
        SystemSecurity,
        SystemAsteroidBeltCount,
        SystemIceFieldCount,
        SystemMoonCount,
        BeltOreType,
        BeltIceType
    }

    public enum FilterCompare
    {
        Equal,
        LargerEqual,
        SmallerEqual,
        Larger,
        Smaller
    }

    [Serializable]
    public class Filter
    {
        public FilterCompare Compare;
        public double DoubleValue;
        public int IntValue;
        public FilterType Type;

        public static string GetCompareString(FilterCompare c)
        {
            switch (c)
            {
                case FilterCompare.Equal:
                    return "=";
                case FilterCompare.Larger:
                    return ">";
                case FilterCompare.LargerEqual:
                    return ">=";
                case FilterCompare.Smaller:
                    return "<";
                case FilterCompare.SmallerEqual:
                    return "<=";
            }
            return "";
        }


        private static bool TestValue(FilterCompare compare, int value, int comparevalue)
        {
            switch (compare)
            {
                case FilterCompare.Equal:
                    return (comparevalue == value);
                case FilterCompare.Larger:
                    return (comparevalue > value);
                case FilterCompare.LargerEqual:
                    return (comparevalue >= value);
                case FilterCompare.Smaller:
                    return (comparevalue < value);
                case FilterCompare.SmallerEqual:
                    return (comparevalue <= value);
            }
            return false;
        }

        private static bool TestValue(FilterCompare compare, double value, double comparevalue)
        {
            switch (compare)
            {
                case FilterCompare.Larger:
                    return (comparevalue > value);
                case FilterCompare.Smaller:
                    return (comparevalue < value);
            }
            return false;
        }


        public bool TestSystem(SolarSystem system)
        {
            int count = 0;

            switch (Type)
            {
                    /*case EVEFilterType.FactionID:
                foreach (var station in system.Stations)
                {
                    if (station.ParentCorpNPC != null &&
                        station.ParentCorpNPC.ParentFaction != null &&
                        station.ParentCorpNPC.ParentFaction.ID == IntValue) return true;
                }
                return false;*/
                    /*case EVEFilterType.CorporationID:
                foreach (var station in system.Stations)
                {
                    if (station.ParentCorpNPC.ID == IntValue) return true;
                }
                return false;*/
                case FilterType.AgentLevel:
                    if (system.Stations == null)
                        return false;
                    foreach (Station station in system.Stations)
                    {
                        if (station.Agents == null)
                            return false;
                        foreach (Agent agent in station.Agents)
                            if (TestValue(Compare, IntValue, agent.Level)) return true;
                    }
                    return false;
                case FilterType.AgentQuality:
                    foreach (Station station in system.Stations)
                    {
                        foreach (Agent agent in station.Agents)
                            if (TestValue(Compare, IntValue, agent.Quality)) return true;
                    }
                    return false;
                case FilterType.AgentIsLocator:
                    foreach (Station station in system.Stations)
                    {
                        foreach (Agent agent in station.Agents)
                            if (agent.Locator) return true;
                    }
                    return false;
                case FilterType.StationReprocessing:
                    foreach (Station station in system.Stations)
                    {
                        foreach (string serv in station.Services)
                        {
                            if (serv == "Reprocessing") return true;
                        }
                    }
                    return false;
                case FilterType.StationManufacturing:
                    foreach (Station station in system.Stations)
                    {
                        foreach (string serv in station.Services)
                        {
                            if (serv == "Manufacturing") return true;
                        }
                    }
                    return false;
                case FilterType.StationCloning:
                    foreach (Station station in system.Stations)
                    {
                        foreach (string serv in station.Services)
                        {
                            if (serv == "Cloning") return true;
                        }
                    }
                    return false;
                case FilterType.RegionID:
                    if (system.RegionID == IntValue) return true;
                    return false;
                case FilterType.SystemSecurity:
                    if (TestValue(Compare, DoubleValue, system.Security)) return true;
                    return false;
                case FilterType.SystemAsteroidBeltCount:
                    foreach (Planet planet in system.Planets)
                        count += planet.Belts;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemIceFieldCount:
                    foreach (Planet planet in system.Planets)
                        count += planet.IceFields;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemMoonCount:
                    foreach (Planet planet in system.Planets)
                        count += planet.Moons;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                    /*case EVEFilterType.BeltOreType:
                var newore = Minerals.GetOres(system);
                return ((newore & (Minerals.OreTypes)IntValue) == (Minerals.OreTypes)IntValue);
            case EVEFilterType.BeltIceType:
                var newice = Minerals.GetIces(system);
                return ((newice & (Minerals.IceTypes)IntValue) == (Minerals.IceTypes)IntValue);*/
            }
            return false;
        }

        public bool TestStation(Station station)
        {
            int count = 0;

            switch (Type)
            {
                    /*case EVEFilterType.FactionID:
                if (station.ParentCorpNPC != null && station.ParentCorpNPC.ParentFaction != null &&
                    station.ParentCorpNPC.ParentFaction.ID == IntValue) return true;
                return false;*/
                    /*case EVEFilterType.CorporationID:
                if (station.ParentCorpNPC != null && station.ParentCorpNPC.ID == IntValue) return true;
                return false;*/
                case FilterType.AgentLevel:
                    for (int j = 0; j < station.Agents.Count; j++)
                        if (TestValue(Compare, IntValue, station.Agents[j].Level)) return true;
                    return false;
                case FilterType.AgentQuality:
                    for (int j = 0; j < station.Agents.Count; j++)
                        if (TestValue(Compare, IntValue, station.Agents[j].Quality)) return true;
                    return false;
                case FilterType.AgentIsLocator:
                    for (int j = 0; j < station.Agents.Count; j++)
                        if (station.Agents[j].Locator) return true;
                    return false;
                    /*case EVEFilterType.AgentDivisionID:
                for (var j = 0; j < station.Agents.Count; j++)
                    if (station.Agents[j].Division.ID == IntValue) return true;
                return false;*/
                    /*case EVEFilterType.AgentTypeID:
                for (var j = 0; j < station.Agents.Count; j++)
                    if (station.Agents[j].Type.ID == IntValue) return true;
                return false*/
                case FilterType.StationReprocessing:
                    foreach (string serv in station.Services)
                    {
                        if (serv == "Reprocessing Plant") return true;
                    }
                    return false;
                case FilterType.StationManufacturing:
                    foreach (string serv in station.Services)
                    {
                        if (serv == "Manufacturing") return true;
                    }
                    return false;
                case FilterType.StationCloning:
                    foreach (string serv in station.Services)
                    {
                        if (serv == "Cloning") return true;
                    }
                    return false;
                case FilterType.RegionID:
                    if (SolarSystem.GetByID(station.SolarSystemID).RegionID == IntValue) return true;
                    return false;
                case FilterType.SystemSecurity:
                    if (TestValue(Compare, DoubleValue, SolarSystem.GetByID(station.SolarSystemID).Security))
                        return true;
                    return false;
                case FilterType.SystemAsteroidBeltCount:
                    foreach (Planet planet in SolarSystem.GetByID(station.SolarSystemID).Planets)
                        count += planet.Belts;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemIceFieldCount:
                    foreach (Planet planet in SolarSystem.GetByID(station.SolarSystemID).Planets)
                        count += planet.IceFields;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemMoonCount:
                    foreach (Planet planet in SolarSystem.GetByID(station.SolarSystemID).Planets)
                        count += planet.Moons;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                    /*case EVEFilterType.BeltOreType:
                var newore = Minerals.GetOres(station.ParentSystem);
                return ((newore & (Minerals.OreTypes)IntValue) == (Minerals.OreTypes)IntValue);
            case EVEFilterType.BeltIceType:
                var newice = Minerals.GetIces(station.ParentSystem);
                return ((newice & (Minerals.IceTypes)IntValue) == (Minerals.IceTypes)IntValue);*/
            }
            return false;
        }


        public bool TestAgent(Agent agent)
        {
            int count = 0;

            switch (Type)
            {
                    /*case EVEFilterType.FactionID:
                if (agent.StationID.ParentCorpNPC != null &&
                    agent.ParentStation.ParentCorpNPC.ParentFaction != null &&
                    agent.ParentStation.ParentCorpNPC.ParentFaction.ID == IntValue) return true;
                return false;
            case EVEFilterType.CorporationID:
                if (agent.ParentStation.ParentCorpNPC != null &&
                    agent.ParentStation.ParentCorpNPC.ID == IntValue) return true;
                return false;*/
                case FilterType.AgentLevel:
                    if (TestValue(Compare, IntValue, agent.Level)) return true;
                    return false;
                case FilterType.AgentQuality:
                    if (TestValue(Compare, IntValue, agent.Quality)) return true;
                    return false;
                case FilterType.AgentIsLocator:
                    if (agent.Locator) return true;
                    return false;
                    /*case EVEFilterType.AgentDivisionID:
                if (agent.Division.ID == IntValue) return true;
                return false;
            case EVEFilterType.AgentTypeID:
                if (agent.AgentType.ID == IntValue) return true;
                return false;*/
                case FilterType.StationReprocessing:
                    foreach (string serv in Station.GetByID(agent.StationID).Services)
                    {
                        if (serv == "Reprocessing") return true;
                    }
                    return false;
                case FilterType.StationManufacturing:
                    foreach (string serv in Station.GetByID(agent.StationID).Services)
                    {
                        if (serv == "Manufacturing") return true;
                    }
                    return false;
                case FilterType.StationCloning:
                    foreach (string serv in Station.GetByID(agent.StationID).Services)
                    {
                        if (serv == "Cloning") return true;
                    }
                    return false;
                case FilterType.RegionID:
                    if (SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID).RegionID == IntValue)
                        return true;
                    return false;
                case FilterType.SystemSecurity:
                    if (TestValue(Compare, DoubleValue,
                                  SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID).Security))
                        return true;
                    return false;
                case FilterType.SystemAsteroidBeltCount:
                    foreach (
                        Planet planet in SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID).Planets)
                        count += planet.Belts;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemIceFieldCount:
                    foreach (
                        Planet planet in SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID).Planets)
                        count += planet.IceFields;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                case FilterType.SystemMoonCount:
                    foreach (
                        Planet planet in SolarSystem.GetByID(Station.GetByID(agent.StationID).SolarSystemID).Planets)
                        count += planet.Moons;
                    if (TestValue(Compare, IntValue, count)) return true;
                    return false;
                    /*case EVEFilterType.BeltOreType:
                var newore = Minerals.GetOres(agent.ParentStation.ParentSystem);
                return ((newore & (Minerals.OreTypes)IntValue) == (Minerals.OreTypes)IntValue);
            case EVEFilterType.BeltIceType:
                var newice = Minerals.GetIces(agent.ParentStation.ParentSystem);
                return ((newice & (Minerals.IceTypes)IntValue) == (Minerals.IceTypes)IntValue);*/
            }
            return false;
        }
    }
}