﻿using System.Xml.Serialization;

namespace libEveMapNG.RestAPI
{
    [XmlType(AnonymousType = true, Namespace = "urn:goonfleet:bridgeplanner:1")]
    [XmlRoot("bridge-list", Namespace = "urn:goonfleet:bridgeplanner:1", IsNullable = false)]
    public class BridgeList
    {
        [XmlArray("bridges", IsNullable = false)]
        [XmlArrayItem("bridge", IsNullable = false)]
        public Bridge[] Bridges { get; set; }
    }

    [XmlType("bridge", AnonymousType = true, Namespace = "urn:goonfleet:bridgeplanner:1")]
    public class Bridge
    {
        [XmlElement("from")]
        public BridgeEndpoint From { get; set; }

        [XmlElement("to")]
        public BridgeEndpoint To { get; set; }

        [XmlAttribute("status")]
        public string Status { get; set; }

        [XmlAttribute("password")]
        public string Password { get; set; }

        [XmlAttribute("color")]
        public string Color { get; set; }

        [XmlAttribute("corporation")]
        public string Corporation { get; set; }
    }

    [XmlType(AnonymousType = true, Namespace = "urn:goonfleet:bridgeplanner:1")]
    public class BridgeEndpoint
    {
        [XmlAttribute("planet")]
        public int Planet { get; set; }

        [XmlAttribute("system-name")]
        public string System { get; set; }

        [XmlAttribute("system-id")]
        public int SystemID { get; set; }

        [XmlAttribute("moon")]
        public int Moon { get; set; }
    }
}