using System;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace libEveMapNG.Utility
{
    public static class Serializer
    {
        private static readonly BinaryFormatter Formatter = new BinaryFormatter();

        public static void WriteToAppData<T>(string fileName, T objectData)
        {
            string pathedFileName =
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\EVE-Map NG\\",
                             fileName);
            using (FileStream fStream = new FileStream(pathedFileName, FileMode.Create))
                Formatter.Serialize(fStream, objectData);
        }

        public static T ReadFromAppData<T>(string fileName)
        {
#if DEBUG
            Debug.WriteLine(String.Format("Loading: {0}", fileName));
#endif
            string pathedFileName =
                Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\EVE-Map NG\\",
                             fileName);
            using (FileStream reader = new FileStream(pathedFileName, FileMode.Open))
                return (T) Formatter.Deserialize(reader);
        }

        public static T ReadFromFile<T>(string fileName)
        {
            using (FileStream reader = new FileStream(fileName, FileMode.Open))
                return (T) Formatter.Deserialize(reader);
        }

        public static void WriteToFile<T>(string fileName, T objectData)
        {
            using (FileStream fStream = new FileStream(fileName, FileMode.Create))
                Formatter.Serialize(fStream, objectData);
        }
    }
}