using System;

namespace libeveapi
{
    /// <summary>
    ///   Contains the Current Skill in Training
    /// </summary>
    public class SkillInTraining : ApiResponse
    {
        /// <summary>
        ///   True if a skill is currently training, false is no skill is training
        /// </summary>
        public bool SkillCurrentlyInTraining { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Server time when skill training completes in ccp time
        ///   Minvalue - when no skill training
        /// </summary>
        public DateTime TrainingEndTime { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Server time when skill training started in ccp time
        ///   Minvalue - when no skill training
        /// </summary>
        public DateTime TrainingStartTime { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Server time when skill training completes in local time
        ///   Minvalue - when no skill training
        /// </summary>
        public DateTime TrainingEndTimeLocal { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Server time when skill training started in local time
        ///   Minvalue - when no skill training
        /// </summary>
        public DateTime TrainingStartTimeLocal { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Id of skill in training
        ///   0 - when no skill training
        /// </summary>
        public int TrainingTypeId { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Skill Points at training start
        ///   0 - when no skill training
        /// </summary>
        public int TrainingStartSP { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Skill Points after training end
        ///   0 - when no skill training
        /// </summary>
        public int TrainingDestinationSP { get; set; }

        /// 
        /// 
        /// <summary>
        ///   Skill level being trained
        ///   0 - when no skill training
        /// </summary>
        public int TrainingToLevel { get; set; }
    }
}